Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/SelfTest/src/main.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/SelfTest/src/main.cpp	(revision 108)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/SelfTest/src/main.cpp	(revision 111)
@@ -15,35 +15,36 @@
   err (_("<Usage> %s name_instance list_params.\n"),argv[0]);
   err (_("list_params is :\n"));
-  err (_(" * nb_context                                                 (uint32_t         )\n"));
-  err (_(" * nb_decod_unit                                              (uint32_t         )\n"));
-  err (_(" * size_general_data                                          (uint32_t         )\n"));
-  err (_(" * size_ifetch_queue             [nb_context]                 (uint32_t         )\n"));
-  err (_(" * nb_inst_fetch                 [nb_context]                 (uint32_t         )\n"));
-  err (_(" * link_context_to_decod_unit    [nb_context]                 (uint32_t         )\n"));
-  err (_(" * size_decod_queue              [nb_decod_unit]              (uint32_t         )\n"));
-  err (_(" * nb_inst_decod                 [nb_decod_unit]              (uint32_t         )\n"));
-  err (_(" * nb_context_select             [nb_decod_unit]              (uint32_t         )\n"));
-  err (_(" * context_select_priority       [nb_decod_unit]              (Tpriority_t      )\n"));
-  err (_(" * context_select_load_balancing [nb_decod_unit]              (Tload_balancing_t)\n"));
-  err (_(" * nb_inst_branch_predict                                     (uint32_t         )\n"));
-  err (_(" * nb_inst_branch_decod                                       (uint32_t         )\n"));
-  err (_(" * nb_inst_branch_update                                      (uint32_t         )\n"));
-  err (_(" * nb_inst_branch_complete                                    (uint32_t         )\n"));
-  err (_(" * btb_size_queue                                             (uint32_t         )\n"));
-  err (_(" * btb_associativity                                          (uint32_t         )\n"));
-  err (_(" * btb_size_counter                                           (uint32_t         )\n"));
-  err (_(" * btb_victim_scheme                                          (Tvictim_t        )\n"));
-  err (_(" * dir_predictor_scheme                                       (Tpredictor_t     )\n"));
-  err (_(" * dir_have_bht                  [3]                          (bool             )\n"));
-  err (_(" * dir_bht_size_shifter          [3]                          (uint32_t         )\n"));
-  err (_(" * dir_bht_nb_shifter            [3]                          (uint32_t         )\n"));
-  err (_(" * dir_have_pht                  [3]                          (bool             )\n"));
-  err (_(" * dir_pht_size_counter          [3]                          (uint32_t         )\n"));
-  err (_(" * dir_pht_nb_counter            [3]                          (uint32_t         )\n"));
-  err (_(" * dir_pht_size_address_share    [3]                          (uint32_t         )\n"));
-  err (_(" * ras_size_queue                [nb_context]                 (uint32_t         )\n"));
-  err (_(" * upt_size_queue                [nb_context]                 (uint32_t         )\n"));
-  err (_(" * ufpt_size_queue               [nb_context]                 (uint32_t         )\n"));
-  err (_(" * size_inst_commit                                           (uint32_t         )\n"));
+  err (_(" * nb_context                                                 (uint32_t             )\n"));
+  err (_(" * nb_decod_unit                                              (uint32_t             )\n"));
+  err (_(" * size_general_data                                          (uint32_t             )\n"));
+  err (_(" * size_ifetch_queue             [nb_context]                 (uint32_t             )\n"));
+  err (_(" * nb_inst_fetch                 [nb_context]                 (uint32_t             )\n"));
+  err (_(" * link_context_to_decod_unit    [nb_context]                 (uint32_t             )\n"));
+  err (_(" * size_decod_queue              [nb_decod_unit]              (uint32_t             )\n"));
+  err (_(" * decod_queue_scheme            [nb_decod_unit]              (Tdecod_queue_scheme_t)\n"));
+  err (_(" * nb_inst_decod                 [nb_decod_unit]              (uint32_t             )\n"));
+  err (_(" * nb_context_select             [nb_decod_unit]              (uint32_t             )\n"));
+  err (_(" * context_select_priority       [nb_decod_unit]              (Tpriority_t          )\n"));
+  err (_(" * context_select_load_balancing [nb_decod_unit]              (Tload_balancing_t    )\n"));
+  err (_(" * nb_inst_branch_predict                                     (uint32_t             )\n"));
+  err (_(" * nb_inst_branch_decod                                       (uint32_t             )\n"));
+  err (_(" * nb_inst_branch_update                                      (uint32_t             )\n"));
+  err (_(" * nb_inst_branch_complete                                    (uint32_t             )\n"));
+  err (_(" * btb_size_queue                                             (uint32_t             )\n"));
+  err (_(" * btb_associativity                                          (uint32_t             )\n"));
+  err (_(" * btb_size_counter                                           (uint32_t             )\n"));
+  err (_(" * btb_victim_scheme                                          (Tvictim_t            )\n"));
+  err (_(" * dir_predictor_scheme                                       (Tpredictor_t         )\n"));
+  err (_(" * dir_have_bht                  [3]                          (bool                 )\n"));
+  err (_(" * dir_bht_size_shifter          [3]                          (uint32_t             )\n"));
+  err (_(" * dir_bht_nb_shifter            [3]                          (uint32_t             )\n"));
+  err (_(" * dir_have_pht                  [3]                          (bool                 )\n"));
+  err (_(" * dir_pht_size_counter          [3]                          (uint32_t             )\n"));
+  err (_(" * dir_pht_nb_counter            [3]                          (uint32_t             )\n"));
+  err (_(" * dir_pht_size_address_share    [3]                          (uint32_t             )\n"));
+  err (_(" * ras_size_queue                [nb_context]                 (uint32_t             )\n"));
+  err (_(" * upt_size_queue                [nb_context]                 (uint32_t             )\n"));
+  err (_(" * ufpt_size_queue               [nb_context]                 (uint32_t             )\n"));
+  err (_(" * size_inst_commit                                           (uint32_t             )\n"));
 
   exit (1);
@@ -70,8 +71,8 @@
   uint32_t             _nb_decod_unit                     = fromString<uint32_t         >(argv[x++]);
 
-  if (argc != static_cast<int>(2+NB_PARAMS+6*_nb_context+5*_nb_decod_unit))
+  if (argc != static_cast<int>(2+NB_PARAMS+6*_nb_context+6*_nb_decod_unit))
     {
       msg("argc                : %d\n",argc);
-      msg("all                 : %d\n",(2+NB_PARAMS+5*_nb_context+5*_nb_decod_unit));
+      msg("all                 : %d\n",(2+NB_PARAMS+6*_nb_context+5*_nb_decod_unit));
       msg("_nb_context         : %d\n",_nb_context);
       msg("_nb_decod_unit      : %d\n",_nb_decod_unit);
@@ -103,4 +104,8 @@
   for (uint32_t i=0; i<_nb_decod_unit; ++i)
     _size_decod_queue [i] = fromString<uint32_t>(argv[x++]);
+
+  decod_unit::decod_queue::Tdecod_queue_scheme_t * _decod_queue_scheme = new decod_unit::decod_queue::Tdecod_queue_scheme_t [_nb_decod_unit];
+  for (uint32_t i=0; i<_nb_decod_unit; ++i)
+    _decod_queue_scheme [i] = fromString<decod_unit::decod_queue::Tdecod_queue_scheme_t>(argv[x++]);
 
   uint32_t           * _nb_inst_decod                     = new uint32_t [_nb_decod_unit];
@@ -166,4 +171,9 @@
   uint32_t             _size_inst_commit                  = fromString<uint32_t>(argv[x++]);
 
+  uint32_t             _nb_thread = _nb_context;
+  uint32_t           * _translate_num_context_to_num_thread = new uint32_t [_nb_context];
+  for (uint32_t i=0; i<_nb_context; ++i)
+    _translate_num_context_to_num_thread [i] = i;
+
   int _return = EXIT_SUCCESS;
   try 
@@ -180,4 +190,5 @@
          _link_context_to_decod_unit          ,
          _size_decod_queue                    ,
+         _decod_queue_scheme                  ,
          _nb_inst_decod                       ,
          _nb_context_select                   ,
@@ -204,4 +215,6 @@
          _ufpt_size_queue                     ,
          _size_inst_commit                    ,
+         _nb_thread                           ,
+         _translate_num_context_to_num_thread ,
          true // is_toplevel
          );
@@ -230,4 +243,5 @@
     }
 
+  delete [] _translate_num_context_to_num_thread ;
   delete [] _dir_have_bht                        ;
   delete [] _dir_bht_size_shifter                ;
@@ -244,4 +258,5 @@
   delete [] _nb_context_select                 ;
   delete [] _nb_inst_decod                     ;
+  delete [] _decod_queue_scheme                ;
   delete [] _size_decod_queue                  ;
   delete [] _link_context_to_decod_unit        ;
